"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _webpack = _interopRequireDefault(require("webpack"));

var _WebpackConfigValidator = _interopRequireDefault(require("./WebpackConfigValidator.js"));

const debug = require("debug")("phenomic:plugin:bundler-webpack");

var _default = config => {
  let webpackConfig;

  const userWebpackConfigPath = _path.default.join(config.path, "webpack.config.js");

  if (_fs.default.existsSync(userWebpackConfigPath)) {
    // $FlowFixMe no I can't
    webpackConfig = require(userWebpackConfigPath);
    webpackConfig = (webpackConfig.default ? webpackConfig.default : webpackConfig)(config);
    debug("webpack.config.js used");
  } else {
    debug("webpack.config.js not found");

    const userWebpackConfigBabelPath = _path.default.join(config.path, "webpack.config.babel.js");

    if (_fs.default.existsSync(userWebpackConfigBabelPath)) {
      // $FlowFixMe no I can't
      webpackConfig = require(userWebpackConfigBabelPath);
      webpackConfig = (webpackConfig.default ? webpackConfig.default : webpackConfig)(config);
      debug("webpack.config.babel.js used");
    } else {
      debug("webpack.config.babel.js not found"); // $FlowFixMe no I can't

      webpackConfig = require(_path.default.join(__dirname, "webpack.config.js"))(config);
      debug("default webpack config used");
    }
  }

  (0, _WebpackConfigValidator.default)(webpackConfig, config);
  debug(webpackConfig);
  return (0, _objectSpread2.default)({}, webpackConfig, {
    plugins: [...(webpackConfig.plugins || []), new _webpack.default.DefinePlugin({
      "process.env.NODE_ENV": JSON.stringify(process.env.NODE_ENV)
    })]
  });
};

exports.default = _default;