"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _webpack = _interopRequireDefault(require("webpack"));

var _logger = _interopRequireDefault(require("@phenomic/core/lib/logger"));

const pluginName = "@phenomic/plugin-bundler-webpack";
const log = (0, _logger.default)(pluginName);

function _default(webpackConfig) {
  return new Promise((resolve, reject) => {
    // $FlowFixMe interface sucks
    (0, _webpack.default)(webpackConfig).run((err, stats) => {
      if (err) {
        reject(err);
      }

      if (stats.hasWarnings()) {
        log.warn(stats.toString(webpackConfig.stats).trim());
      }

      if (stats.hasErrors()) {
        log.error(stats.toString(webpackConfig.stats).trim());
        reject("webpack build failed with errors");
      }

      resolve(stats);
    });
  });
}